set size 1.0,1.0
set origin 0,0

set grid
set key right bottom
set terminal png size 1280, 720 crop

set out "result.png"
set multiplot layout 1,2 rowsfirst scale 1.0,1.0

set size 0.5,0.5
set origin 0,0.5
set xlabel "Time (s)"
set ylabel "Instantaneous throughput (Mb/s)"
plot "flow1.txt" using 1:2 title "Crew" with lines, "flow2.txt" using 1:2 title "Harbour" with lines, "flow3.txt" using 1:2 title "TCP" with lines

set size 0.5,0.5
set origin 0,0
set xlabel "Time (s)"
set ylabel "Accumulative throughput (Mb/s)"
plot "flow1.txt" using 1:3 title "Crew" with lines, "flow2.txt" using 1:3 title "Harbour" with lines, "flow3.txt" using 1:3 title "TCP" with lines, "aggregate_tfrcpsnr.txt" using 1:5 title "Video" with lines


set yrange [30:45]
set size 0.5,0.5
set origin 0.5,0.5
set ylabel "Instantaneus PSNR (dBs)"
plot "psnr1.txt" using 1:2 title "Crew" with lines, "psnr2.txt" using 1:2 title "Harbour" with lines

set size 0.5,0.5
set origin 0.5,0
set ylabel "Accumulative PSNR (dBs)"
plot "psnr1.txt" using 1:3 title "Crew" with lines, "psnr2.txt" using 1:3 title "Harbour" with lines





