#!/bin/bash

NS=../ns-2.34/ns
THROUGHPUTPSNR=../throughput_to_psnr/throughput_to_psnr

CAPACITY=10
BOTTLENECK=0
ALPHA=0.05
BETA=0.8
RTT1=100
RTT2=100
RTT3=100
RTT4=100
START1=1.0
START2=1.0
START3=1.0
START4=1.0
VID_PROFILE1=2
VID_PROFILE2=3
VID_PROFILE3=3
VID_PROFILE4=4

for RTT1 in `seq 80 20 160`
do
	for RTT2 in `seq 80 20 160`
	do
	for RTT3 in `seq 80 20 160`
	do

		#1: BW x Delay 0: 100 pkts
		for BOTTLENECK in `seq 0 1` 
		do
			echo "$NS tfrc.tcl $CAPACITY $BOTTLENECK $ALPHA $BETA $RTT1 $RTT2 $RTT3 $RTT4 $START1 $START2 $START3 $START4 $VID_PROFILE1 $VID_PROFILE2 $VID_PROFILE3 $VID_PROFILE4"
			$NS tfrc.tcl $CAPACITY $BOTTLENECK $ALPHA $BETA $RTT1 $RTT2 $RTT3 $RTT4 $START1 $START2 $START3 $START4 $VID_PROFILE1 $VID_PROFILE2 $VID_PROFILE3 $VID_PROFILE4
			perl throughput.pl out.tr 6 tcpFriend 1 > flow1.txt 
			perl throughput.pl out.tr 7 tcpFriend 1 > flow2.txt
			perl throughput.pl out.tr 8 tcp 1 > flow3.txt
			$THROUGHPUTPSNR flow1.txt $VID_PROFILE1 psnr1.txt 
			$THROUGHPUTPSNR flow2.txt $VID_PROFILE2 psnr2.txt
			pr -m -t -s\  flow1.txt flow2.txt | awk '{print $1, $2+$5, $3+$6, ($2+$5)/2, ($3+$6)/2}' > aggregate_tfrcpsnr.txt
			awk 'BEGIN{count=0;sum=0} {if ($2!=0) {sum+=$2; count++}; if (count!=0) {print $1, $2, sum/count} else {print $1, $2, 0} }' psnr1.txt > tmp
			mv tmp psnr1.txt
			awk 'BEGIN{count=0;sum=0} {if ($2!=0) {sum+=$2; count++}; if (count!=0) {print $1, $2, sum/count} else {print $1, $2, 0} }' psnr2.txt > tmp
			mv tmp psnr2.txt
			gnuplot plot.gp
			PREFIX="Cap_"$CAPACITY"_Bot_"$BOTTLENECK"_RTT1_"$RTT1"_RTT2_"$RTT2"_RTT3_"$RTT3"_S1_"$START1"_S2_"$START2"_S3_"$START3"_vid1_"$VID_PROFILE1"_vid2_"$VID_PROFILE2"_vid3_"$VID_PROFILE3
			cp "flow1.txt" $PREFIX"_flow1.data"
			cp "flow2.txt" $PREFIX"_flow2.data"
			cp "flow3.txt" $PREFIX"_flow3.data"
			cp "psnr1.txt" $PREFIX"_psnr1.data"
			cp "psnr2.txt" $PREFIX"_psnr2.data"
			cp "result.png" $PREFIX".png"
		done
	done
	done
done
