set ns [new Simulator]
set testTime 60.0 

if {$argc < 15} {
        puts stderr "ns tfrc.tcl <bottleneck capacity> <bottlenect queue size (1:BDP, 0: 150 packets)> <alpha> <beta> <rtt1> <rtt2> <rtt3> <rtt4> <starting time flow 1> <starting time flow 2> <starting time flow 3> <starting time flow 4>  <video profile 1> <video profile 2> <video profile 3> <video profile 4>" 
        exit 1
}

set C [lindex $argv 0]
set bottle [lindex $argv 1]
set alpha [lindex $argv 2]
set beta [lindex $argv 3]
set rtt1 [lindex $argv 4]
set rtt2 [lindex $argv 5]
set rtt3 [lindex $argv 6]
set rtt4 [lindex $argv 7]
set start1 [lindex $argv 8]
set start2 [lindex $argv 9]
set start3 [lindex $argv 10]
set start4 [lindex $argv 11]
set vid_profile1 [lindex $argv 12]
set vid_profile2 [lindex $argv 13]
set vid_profile3 [lindex $argv 14]
set vid_profile4 [lindex $argv 15]

#open the trace file
set tracefile1 [open out.tr w]
$ns trace-all $tracefile1

# Set up the network topology shown at the top of this file:
set s1 [$ns node]
set s2 [$ns node]
set s3 [$ns node]
set s4 [$ns node]
set e1 [$ns node]
set e2 [$ns node]
set dest1 [$ns node]
set dest2 [$ns node]
set dest3 [$ns node]
set dest4 [$ns node]

$ns duplex-link $s1 $e1 100Mb [expr ($rtt1-40)/2]ms DropTail
$ns duplex-link $s2 $e1 100Mb [expr ($rtt2-40)/2]ms DropTail
$ns duplex-link $s3 $e1 100Mb [expr ($rtt3-40)/2]ms DropTail
$ns duplex-link $s4 $e1 100Mb [expr ($rtt4-40)/2]ms DropTail

#set rtt [expr 100]
if {$rtt1 < $rtt2} {
	set rtt [expr $rtt2]
} else {
	set rtt [expr $rtt1]
}
puts "rtt = $rtt"

set bottleneck_queue_size [expr round ( ( $C * $rtt ) / 8 )]

$ns duplex-link $e1 $e2 $C.Mb 10ms DropTail
if { $bottle == "0" } {
    $ns queue-limit $e1 $e2 150
	puts "queue size = 150"
} else {
    $ns queue-limit $e1 $e2 $bottleneck_queue_size
	puts "queue size = $bottleneck_queue_size"
}

#$ns queue-limit $e1 $e2 150
#$ns queue-limit $e1 $e2 $bottleneck_queue_size
#puts "queue size = $bottleneck_queue_size"
$ns duplex-link $e2 $dest1 100Mb 10ms DropTail
$ns duplex-link $e2 $dest2 100Mb 10ms DropTail
$ns duplex-link $e2 $dest3 100Mb 10ms DropTail
$ns duplex-link $e2 $dest4 100Mb 10ms DropTail

# TFRCPSNR
set ftp1 [$ns create-connection TFRCPSNR $s1 TFRCPSNRSink $dest1 0]
set ftp2 [$ns create-connection TFRCPSNR $s2 TFRCPSNRSink $dest2 0]
#set ftp3 [$ns create-connection TFRCPSNR $s1 TFRCPSNRSink $dest1 0]

#set src1 [new Agent/TFRCPSNR]
$ftp1 VideoProfile $vid_profile1
$ftp1 AI_PSNR $alpha
$ftp1 MD_PSNR $beta
#$ftp1 AIMDStrategy 5
#$ftp1 AlgoChoice 2
#set sink1 [new Agent/TFRCPSNRSink]
#$ns attach-agent $s1 $src1
#$ns attach-agent $dest1 $sink1
#$ns connect $src1 $sink1
#set ftp1 [new Application/FTP]
#$ftp1 attach-agent $src1

#set src2 [new Agent/TFRCPSNR]
$ftp2 VideoProfile $vid_profile2
$ftp2 AI_PSNR $alpha
$ftp2 MD_PSNR $beta
#$ftp2 AIMDStrategy 5
#$ftp2 AlgoChoice 2
#et sink2 [new Agent/TFRCPSNRSink]
#ns attach-agent $s2 $src2
#ns attach-agent $dest2 $sink2
#ns connect $src2 $sink2
#et ftp2 [new Application/FTP]
#ftp2 attach-agent $src2

#set src3 [new Agent/TFRCPSNR]
#$src3 VideoProfile $vid_profile3
#$src3 AI_PSNR $alpha
#$src3 MD_PSNR $beta
#$src3 AIMDStrategy 5
#$src3 AlgoChoice 1
#set sink3 [new Agent/TFRCPSNRSink]
#$ns attach-agent $s3 $src3
#$ns attach-agent $dest3 $sink3
#$ns connect $src3 $sink3
#set ftp3 [new Application/FTP]
#$ftp3 attach-agent $src3

set src3 [new Agent/TCP]
$ns attach-agent $s3 $src3
$src3 set window_ [expr 10*200]
$src3 set maxcwnd_ [expr 10*200]
$src3 set windowInit_ 2
set ftp3 [new Application/FTP]
$ftp3 attach-agent $src3
set sink3 [new Agent/TCPSink]
$ns attach-agent $dest3 $sink3
$ns connect $src3 $sink3

proc finish {} {
   global ns tracefile1 C
   $ns flush-trace
   close $tracefile1
   exit 0
}

#2 TFRCPSNR flows
$ns at $start1 "$ftp1 start"
$ns at $testTime "$ftp1 stop"
$ns at $start2 "$ftp2 start"
$ns at $testTime "$ftp2 stop"

$ns at $start3 "$ftp3 start"
$ns at $testTime "$ftp3 stop"
#$ns at $start4 "$ftp4 start"
#$ns at $testTime "$ftp4 stop"

$ns at [expr $testTime+1.0] "finish"

$ns run
